/*! @file
 * @brief
 * declaration of class StaticRelations
 */


#ifndef STATIC_RELATIONS_HEADER_
#define STATIC_RELATIONS_HEADER_


class StaticRelations : private StaticFactorbase
{
 // this class is just here to encapsulate access to the functions
 // which are specific for handling static relations

 private:
  static CRelation* GLS[StaticFactorbase::MaxSize];
   // Gleichungssystem besteht aus Zeigern auf Relationen (Gleichungszeilen),
   // das mit Null-Pointern initialisiert ist, da anfangs noch keine Relationen
   // vorliegen
  static int Fuellung_GLS; // Fllung des Gleichungssystems mit Relationen

  // Fr die Relationen der statischen Faktorbasis
  // streams fr das Datenfile zur Verfgung stellen:
  static filebuf FileBuffer;
  static ostream StaticRelations_to_file;
  static istream StaticRelations_from_file;

 public:
  static void insert(CRelation *GL, const bool do_multi_combine_init=true);
  static void Load();

  static const int Count() { return Fuellung_GLS; }
  static void cleanup_files()
   {
     FileBuffer.close();
     remove(StaticRelationsFile.c_str());
   }
  static void cleanup_memory()
   {
     int count = 0;
     for (int i=0; i<StaticFactorbase::MaxSize; ++i)
      if (GLS[i]) { delete GLS[i]; ++count; }
     Fuellung_GLS=0;
     cout << count << " relations deallocated." << endl;
   }
 friend int main(const int argc, const char* const argv[]);
};

#endif /* STATIC_RELATIONS_HEADER_ */
